/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */

#include "chcksum.h"
#include "tcpvars.h"
#include "ioconfig.h"

/* return the checksum */
unsigned int checksum(xbuffer, xlen, buffer, len)
unsigned char *xbuffer;
unsigned int xlen;
unsigned char *buffer;
unsigned int len;
{
	/* manual math here because of buggy compiler */
	register unsigned int zipper;
	register unsigned long sum = 0;
	register unsigned char *bufptr;

	if(xlen != 0) {
		bufptr = xbuffer; 
		for(zipper = (xlen / 2); zipper > 0; zipper-- ) {
			sum += ((bufptr[0]) << 8 ) + (bufptr[1]);
			bufptr += 2;
		}
	}

	bufptr = buffer; 
	/* sum it */
	for(zipper = (len / 2); zipper > 0; zipper-- ) {
		sum += ((bufptr[0]) << 8 ) + (bufptr[1]);
		bufptr += 2;
	}

	if ( (len & 1) == 1 ) {
		sum += (bufptr[0] & 0xff) << 8;
	}


	while (sum > 0xffff)
		sum = (sum & 0xffff) + (sum >> 16);
	sum = ~sum;
	return((unsigned int)(sum & 0xffff));
}


/* tell link parser who we are and where we belong

0900 libznet.lib chcksum.obj xxLIBRARYxx

*/

