/* (C) 2001-2002 Andrew J. Kroll, Marc Santoro */
/* see file README for license details */
/* 
	ELKS (other UN*X too?) serial tty driver
*/

#include "config.h"

#if USEELKSTTYS /* Include this code? */
#include "elksser.h"
#include "tcpvars.h"
#include <termios.h>
#include <fcntl.h>
/* #include <linuxmt/time.h> */
#include <sys/time.h>
#include <time.h>

#define SERIALDEVICE "/dev/ttyS0"

char HARDDRV[] = "Linux ELKS Serial Driver 0.0.1";
int serfd = 0;

int checkfd(fd)
int fd;
{
	struct timeval tv;
	fd_set fds;
        tv.tv_sec = tv.tv_usec = 0;
	if(fd < 0)
		return(0);
	FD_ZERO(&fds);
	FD_SET(fd, &fds);
	select(fd + 1, &fds, NULL, NULL, &tv);
	if(FD_ISSET(fd, &fds))
		return(1);
	return(0);
}

int fixgetch(VOIDFIX)
{
	unsigned int c = 0;
	read(0, &c, 1);
	return(c);
}

int fixkbhit(VOIDFIX)
{
	return(checkfd(0));
}

void zapbuffers(VOIDFIX)
{
	/* don't do anything */
}

int check_in(VOIDFIX)
{
	/* 
		FIXME!
	
		I'm not sure if elks uses the same IOCTL that linuxser.c uses, 
		so a 1 will atleast allow the code to work... --AJK 
	*/

	return(checkfd(serfd));
}

int check_out(VOIDFIX)
{
	/* fsync(serfd); */
	return(0);
}

void put_data(c)
unsigned char c;
{
	write(serfd, &c, 1);
}

unsigned char get_data(VOIDFIX)
{
	unsigned char c;
	read(serfd, &c, 1);
	return(c);
}

void initializedev(VOIDFIX)
{
	struct termios tio;
	memset(&tio, 0, sizeof(struct termios));
	tio.c_cc[VMIN] = 1;
	tio.c_iflag = IGNPAR;
	tio.c_cflag = B9600 | CS8 | CRTSCTS | CLOCAL | CREAD;
	serfd = open(SERIALDEVICE, O_NOCTTY | O_RDWR);
	if(!serfd)
	{
		perror("open");
		exit(1);
	}
	tcsetattr(serfd, TCSANOW, &tio);
}
#else

void elksser(VOIDFIX)
{
	/* keep compiler happy... */
}

#endif /* USEELKSTTYS */


/* tell link parser who we are and where we belong

1103 libznet.lib elksser.obj xxLIBRARYxx

*/

