/* (C) 2001-2002 Andrew J. Kroll, Marc Santoro */
/* see file README for license details */
/* 
	Linux (other UN*X too?) serial tty driver
*/

#include "config.h"

#if USELINUXTTYS /* Include this code? */
#include "tcpvars.h"
#include <termios.h>
#include <fcntl.h>
#include "linuxser.h"
#include <sys/time.h>
#include <time.h>
#include <asm/ioctls.h>
#define TERMIO termios
#define SERIALDEVICE "/dev/ttyS0"

char HARDDRV[] = "Linux Serial Driver 0.0.3";
int serfd = 0;

struct TERMIO tty_old, tty_new;


int checkfd(fd)
int fd;
{
	struct timeval tv;
	fd_set fds;
        tv.tv_sec = tv.tv_usec = 0;
	if(fd < 0)
		return(0);
	FD_ZERO(&fds);
	FD_SET(fd, &fds);
	select(fd + 1, &fds, NULL, NULL, &tv);
	if(FD_ISSET(fd, &fds))
		return(1);
	return(0);
}

int fixgetch(VOIDFIX)
{
	unsigned int c = 0;
	read(0, &c, 1);
	return(c);
}

int fixkbhit(VOIDFIX)
{
	return(checkfd(0));
}

void zapbuffers(VOIDFIX)
{
	/* don't do anything */
}

int check_in(VOIDFIX)
{
	/* 
		AJK --
		Technically for optimum performance we need to know 
		the serial queue DEPTH. A 1 is better than a zero, however... 
		return(checkfd(serfd));
		can be rewritten as... 
	*/
	
	int count = 0;
	ioctl(serfd, FIONREAD, &count);
	return(count);
	/* Now we can work faster...  -- AJK */
}

int check_out(VOIDFIX)
{
	/* fsync(serfd); */
	return(0);
}

void put_data(c)
unsigned char c;
{
	write(serfd, &c, 1);
}

unsigned char get_data(VOIDFIX)
{
	unsigned char c;
	read(serfd, &c, 1);
	return(c);
}

void inittty(VOIDFIX)
{
	tcgetattr(0, &tty_old);
	tcgetattr(0, &tty_new);
	tty_new.c_iflag |= IGNBRK;
	tty_new.c_lflag = 0;
	tty_new.c_cflag &= ~(PARENB | CSIZE);	/* Disable parity */
	tty_new.c_cflag |= (CREAD | CS8);	/* Set character size = 8 */
	tcsetattr(0, TCSANOW, &tty_new);
}

/* this chunk of code restores the tty via atexit() */
void ttyrestore(VOIDFIX)
{
	tcsetattr(0, TCSANOW, &tty_old);
	exit(0);
}

void initializedev(VOIDFIX)
{
	struct termios tio;
	memset(&tio, 0, sizeof(struct termios));
	tio.c_cc[VMIN] = 1;
	tio.c_iflag = IGNPAR;
	tio.c_cflag = B9600 | CS8 | CRTSCTS | CLOCAL | CREAD;
	serfd = open(SERIALDEVICE, O_NOCTTY | O_RDWR);
	if(!serfd)
	{
		perror("open");
		exit(1);
	}
	tcsetattr(serfd, TCSANOW, &tio);
	inittty();
	atexit(ttyrestore);
}

#else

void linuxser(VOIDFIX)
{
	/* keep compiler happy... */
}

#endif /* USELINUXSER */


/* tell link parser who we are and where we belong

1102 libznet.lib linuxser.obj xxLIBRARYxx

*/


